package display;

import uchicago.src.sim.gui.OvalNetworkItem;
import units.Household;

/**
 * HouseholdNode type which is a subclass of the Node for Household
 *
 */
public class HouseholdNode extends Node {

	/** here household is the node */
	private Household household;

	/** 
	 * Default constructor
	 */
	public HouseholdNode() {
		super();
	}

	/**
	 * Sets household to its node
	 * @param _house
	 */
	public HouseholdNode(Household _house) {
		setHouse(_house);
	}

	/**
	 * Sets the households for this node/
	 */
	public void setHouse(Household _household) {
		this.household = _household;
	}

	/**
	 * Returns the households for this node/
	 * @return
	 */
	public Household getHousehold() {
		return this.household;
	}

	/** This is needed for tests in contains() operation of node lists */	
	public boolean equals(Object o) {
		if (this == o) {
			return true;
		}
		if ((o == null) || !(o instanceof HouseholdNode)) {
			return false;
		}
		HouseholdNode other = (HouseholdNode) o;
		if (this.household != null && other.getHousehold() == this.household) {
			return true;
		}
		return false;
	}
}