package display;

import java.util.List;
import java.util.HashMap;

import uchicago.src.sim.gui.DrawableNonGridNode;
import uchicago.src.sim.gui.RandomGraphLayout;
import uchicago.src.sim.util.Random;

/**
 * 
 * @author ruth
 *
 */
public class PositionPreservingGraphLayout extends RandomGraphLayout {

	int epsilon = 4;

	HashMap<DrawableNonGridNode, Position> nodePositionMap = new HashMap<DrawableNonGridNode, Position>();

	public PositionPreservingGraphLayout(int width, int height) {
		super(width, height);
	}

	public PositionPreservingGraphLayout(List nodes, int width, int height) {
		super(nodes, width, height);
	}

	public void updateLayout() {
		if (update) {
			int n = nodeList.size();
			for (int i = 0; i < n; i++) {
				DrawableNonGridNode node = (DrawableNonGridNode) nodeList
						.get(i);
				if (!nodePositionMap.containsKey(node)) {
					// assign new random position
					node.setX(Random.uniform.nextIntFromTo(0, width - epsilon));
					node
							.setY(Random.uniform.nextIntFromTo(0, height
									- epsilon));
					// store in nodePositionMap
					nodePositionMap.put(node, new Position(node.getX(), node
							.getY()));
				} else {
					// re-assign stored position
					Position p = nodePositionMap.get(node);
					node.setX(p.x);
					node.setY(p.y);
				}
			}
		}
	}

	class Position {
		int x = 0;

		int y = 0;

		Position(int x, int y) {
			this.x = x;
			this.y = y;
		}

		Position(double x, double y) {
			this.x = (int) x;
			this.y = (int) y;
		}
	}
}