package economics;

/**
 * from FAO/WHO/UN ... Tsimane Adult-Equivalent Measures
 */
public class Nutrition {

	public Nutrition() {
	}
	
	/**
	 * Gives the male equivalent for nutritional requirement given age
	 */
	public int requiredMalePerCentage(int age) {
		if (age >= 60) {
			return 62;
		} else if (age <= 2) {
			return 33;
		} else if (age <= 5) {
			return 48;
		} else if (age <= 9) {
			return 64;
		} else if (age <= 13) {
			return 74;
		} else if (age <= 17) {
			return 87;
		} else {
			return 100;
		}
	}

	/**
	 * Gives the female equivalent for nutritional requirement given age 
	 * @param age
	 * @return
	 */
	public int requiredFemalePerCentage(int age) {
		if (age >= 60) {
			return 57;
		} else if (age <= 2) {
			return 35;
		} else if (age <= 5) {
			return 53;
		} else if (age <= 9) {
			return 53;
		} else if (age <= 13) {
			return 66;
		} else if (age <= 17) {
			return 70;
		} else {
			return 75;
		}
	}
}