package health;

import uchicago.src.sim.util.Random;
import cern.jet.math.Functions;
/**
 * Fermi function for food intake requiremnt of an agent.
 * @author shah
 *
 */
public class Fermi {
	double beta = 5, zStar = 2;

	public Fermi() {
		Random.createUniform();
	}

	public double returnValueOfFunction(double z) {
		return (Functions.exp.apply(beta * (z - zStar) + 1));
	}

	public double returnChildFoodIntake(int age) {
		Double value = new Double(returnValueOfFunction((double) age / 10));
		value *= 10;
		return value.doubleValue();
	}

	public static void main(String[] args) {
		Fermi fermi = new Fermi();
		for (int i = 0; i < 25; i++) {
			int age = Random.uniform.nextIntFromTo(6, 12);
			double val = fermi.returnValueOfFunction((double) age / 10);
			System.out.println("i: " + i + " age: " + age + " val: " + val
					* 1000);
		}
	}

}
