/**
 * 
 */
package infrastructure;

import cern.jet.random.engine.RandomEngine;

/**
 * @author Ruth Meyer
 *
 */
public class EmpiricalDiscreteDist {
	RandomEngine randomGenerator;
	double[] probabilities;

	public EmpiricalDiscreteDist(double[] probabilities, RandomEngine randomGenerator){
		this.randomGenerator = randomGenerator;
		this.probabilities = new double[probabilities.length]; 
		// turn probs into cumulative probs
		this.probabilities[0] = probabilities[0];
		for (int i = 1; i < probabilities.length; i++){
			this.probabilities[i] = this.probabilities[i-1] + probabilities[i]; 
		}			
		// needs to check that length of values and prob. is the same
		// and that all the probs add up to 1
		// for now, let's just assume it's correct
	}

	public int nextInt(){
		int index = 0;
		double randomNumber = randomGenerator.nextDouble();
		while (index < this.probabilities.length && randomNumber > this.probabilities[index]){
			index++;
		}
		return index;
	}

}
