/**
 * 
 */
package infrastructure;

import cern.jet.random.engine.RandomEngine;

/**
 * @author Ruth Meyer
 *
 */
public class EmpiricalDiscreteDistArray {
	EmpiricalDiscreteDist[] distArray;
	double[] intervals;

	public EmpiricalDiscreteDistArray(double[] intervals, double[][] probabilities, RandomEngine randomGenerator){
		this.intervals = intervals;
		this.distArray = new EmpiricalDiscreteDist[intervals.length];
		for (int i = 0; i < intervals.length; i++){
			distArray[i] = new EmpiricalDiscreteDist(probabilities[i], randomGenerator);
		}
	}

	public int nextInt(double x){
		// determine in which interval x falls
		int index = 0;
		while (index < intervals.length && x > intervals[index]){
			index++;
		}
		// return random number from x's distribution
		return distArray[index].nextInt();
	}
}



