package infrastructure;

public class Settings {
	/**Minimum age for sexually active female */
	public static final int WOMEN_SEX_MINIMUM_AGE = 13;
	/**Maximum age for sexually active female */
	public static final int WOMEN_SEX_MAXIMUM_AGE = 45;

//	public static final int PAJEK_INTERVAL = 10; 
	public static final int PAJEK_INTERVAL = 30;
		
	public static final boolean PRINT_OUTPUT = true;
	/**Should deduct health expenditure */
	public static final boolean IS_HEALTH_EXPENDITURE = true;
	/**Should record the networks */
	public static final boolean RECORD_NETWORK = true;
	/**Should show model GUI */
	public static final boolean SHOW_GUI = false;
	public static final boolean IS_FUNERAL_CLUB = true;
	/**Should introduce HIV/AIDS */
	public static final boolean IS_HIV = true;

	/**
	 * Types of Stokvel Messages
	 * 	 */
	public static final class MESSAGE_TYPE {
		public static final int NO_MESSAGE = 0;
		public static final int CLUB_INVITATION = 1;
		public static final int ACCEPTANCE = 2;
		public static final int REJECTION = 3;
	}
	
	/**
	 * Types of Sexual Partnerships Messages 
	 *
	 */
	public static final class COURTSHIP_MESSAGE {
		public static final int NO_MESSAGE = 0;
		public static final int COURTSHIP_OFFER = 1;
		public static final int ACCEPTANCE = 2;
		public static final int REJECTION = 3;
		public static final int WAITING = 4;
	}

	/**
	 * Types of agents' gender
	 *
	 */
	public static class GENDER {
		public static final int FEMALE = 0;
		public static final int MALE = 1;		
	}		

	/**
	 * Agents' age groups
	 * 
	 */
	public static class AGE_GROUP {
		public static final int CHILD = 0;
		public static final int ADULT = 1;
		public static final int SENIOR = 2;		
	}	
	
	/**Child agen limit */
	public static final int CHILD_AGE_LIMIT = 16;
	/**Adult agen limit */
	public static final int ADULT_AGE_LIMIT = 45;
	/**Male sexually active age limit */
	public static final int MALE_SEX_AGE_LIMIT = 55;
	
	/**
	 * Types of healt status and stages for agents
	 * 
	 * */
	public static class HEALTH_STATUS {			
		public static final int DISABLE = 0;		
		public static final int OLD_AGE_SICKNESS = 1;	
		public static final int ILL = 2;
		public static final int WELL = 3;
		public static final int EARLY_HIV = 4;
		public static final int MIDDLE_HIV = 5;
		public static final int LATE_HIV = 6;
		public static final int AIDS = 7;
	}		

//	public static int NUM_RECORDS = 961;
	public static int NUM_RECORDS = 1961;
	
	/**	Rich households limit */
	//magic number
	public static int RICH_HOUSEHOLD_CRITERIA = 15000;
//	public static int RICH_HOUSEHOLD_CRITERIA = 5000;
//	public static int RICH_HOUSEHOLD_CRITERIA = 10000;

	/** employment choices for piecewise jobs*/
	public static class EMPLOYMENT_STRATEGIES {
		public static final int RANDOM_STRATEGY = 0;
		public static final int KIN_FIRST_STRATEGY = 1;
		public static final int RELIABILITY_STRATEGY = 2;
	}

	/** Lobolo upper limit */
	public static final int LOBOLA_AMOUNT = 10000;		
//	public static final int LEBOLA_AMOUNT = 5000;

	/**
	 * Marital status for agents
	 */
	public static final class MARITAL_STATUS {
		public static final int SINGLE = 0;
		public static final int MARRIED = 1;
		public static final int WIDOWED = 2;
		public static final int HAS_PARTNER = 2;
	}	

	/**
	 * Jobs message types
	 * 	
	 */
	public static final class JOB_MESSAGE_TYPE {
		public static final int NO_MESSAGE = 0;
		public static final int JOB_ANNOUNCEMENT = 1;
		public static final int JOB_APPLICATION = 2;	
		public static final int ACCEPTANCE = 3;
		public static final int REJECTION = 4;
		public static final int JOB_REFERAL = 5;
	}		
	
//	http://www.fao.org/docrep/008/y5744e/y5744e09.htm
	/*
	 * Among the countries of the world hardest hit by HIV/AIDS are South Africa and Botswana (Table 17).
	 *  In Botswana, almost 36 percent of all adults are infected with HIV/AIDS. 
	 *  Life expectancy has dropped from 61 years seven years ago to 39 years today, 
	 *  and the figure is projected to fall below 29 years by 2010. Without HIV/AIDS, 
	 *  it would have been more than 66 years. 
	 */
	//also: http://www.nwpg.gov.za/Premiers/docs/BAROMETER/Social/Social%20Cluster%20-%203.doc
	public static final double MEAN_LIFE_EXPECTANCY = 63;
	public static final double SD_LIFE_EXPECTANCY = 11;

	/**
	 * In Ziervogel et al. (2005) [UNRAVEL REPORT], it's mentioned that the pension grants can support
	 * entire households since 750 per month is the pension and assuming 6 people on average, in a household
	 * we assume that 125 Rands are required for each member, i.e. 750/6.  
	 * But since grant not only allows to buy food, but also transport and electricity etc. (funeral expenditure, 
	 * savings clubs etc.), 
	 * "Maize prices fluctuate. We got costs of maize in Burghersfort - near to Radar
	 * 	site - earlier this year and 25kg cost R80"  - snipped from gina email, aug'07/06
	 */	
	public static final int MIN_MONEY_TO_FEED = 120;
	public static final int MAX_MONEY_TO_FEED = 165;
//	http://www.sarpn.org.za/EventPapers/Land/20010605Bonti.pdf
//	public static final int MIN_MONEY_TO_FEED = 165;
//	public static final int MAX_MONEY_TO_FEED = 210;

//	public static final int MIN_MONEY_TO_FEED = 45;
//	public static final int MAX_MONEY_TO_FEED = 65;

	/**
	 * Feed status for the agents
	 */
	public static final class FEED_STATUS {
		public static final int NOT_FED = 0;		
		public static final int FULL_FED = 1;
		public static final int HALF_FED = 2;		
	}

		
	public static class GRANTS {
		/* grant types */			
		//from SA 2007 Budget
		public static final int NO_GRANT = 0;
		public static final int DISABILITY_GRANT = 870;
		public static final int PENSION_GRANT = 870;
		public static final int CHILD_GRANT = 200;
		public static final int FOSTER_CARE_GRANT = 620;
		//pre-April 2007 grant values
//		public static final int NO_GRANT = 0;
//		public static final int DISABILITY_GRANT = 300;
//		public static final int PENSION_GRANT = 560;
//		public static final int CHILD_GRANT = 125;
//		public static final int FOSTER_CARE_GRANT = 175;

		public static final int CHILD_GRANT_AGE = 13; 
		public static final int FOSTER_CARE_GRANT_AGE = 18;
		
		/** right now, what we know is that it's low ... need to 
		 * digout from the fieldwork - this from the anecdotal account
		 * */	
//		public static final double DISABILITY_GRANT_PROBABILITY = 0.20;
		public static final double DISABILITY_GRANT_PROBABILITY = 0.1111;

		//from SA 2007 Budget 
		/** Pension age for females */ 
		public static final int PENSION_AGE_FEMALE = 55;
		/** Pension age for males */
		public static final int PENSION_AGE_MALE = 60;		
	}

	/**
	 * The remittance amount is set fixed at the moment; we would like to 
	 * make it appear more plausible as further data are made available.
	 * magic number 
	 */
	public static final class REMITTANCE  {
		public static final int SKEWED_REMITTANCE = 1000;
		public static final int MEAN = 200;
		public static final int STD_DEV = 50;
		public static final int SKEWED_PIECE_WORK = 475;
	}	


	/*	public static final class REMITTANCE  {
		public static final int SKEWED_REMITTANCE = 500;
		public static final int MEAN = 200;
		public static final int STD_DEV = 50;
		public static final int SKEWED_PIECE_WORK = 175;
	}	
	 */

	//magic number
	/** Probability for deciding to marry*/
	public static final double MARRIAGE_PROBABILITY = 0.20;	
//	public static final double MARRIAGE_PROBABILITY = 0.15;
//	public static final double MARRIAGE_PROBABILITY = 1.0;
	/*it's for each household ... the value is taken from Heuveline (2004) in which
	 * he says the birth rate is 0.3 per person-year in many of the most affected areas
	 * ... What's required to assure is that I'm using it correctly, or not ???	 * 
	 */ 
	
//	public static final double BIRTH_RATE = 19;
//	public static final double BIRTH_RATE = 31;
	public static final double BIRTH_RATE = 23;
	public static final double INFANT_MORTALITY_RATE = 52;

	public static final double MTCT_RATE = 0.30;

	/*initial fund for funeral club ... this is just a magic number... where money comes from somewhere
	 * and is assumed to be there before the simulation starts ... of course, a club's money may increase
	 * and most likely to decrease ... in case of being broken ... the members may opt to join another, if possible
	 */
	public static final int FUNERALCLUB_INITIAL_MONEY = 10000;	 
//	public static final int FUNERALCLUB_INITIAL_MONEY = 5000;


	/*from validation trip Oct 2007: acc. to the villagers, 
	 * funeral cost would vary from 6000 to 1000 Rand 
	 * this is sampled from normal distribution*/
//	public static final int FUNERAL_COST = 5000;
//	public static final int FUNERAL_COST = 7500;
	public static final int FUNERAL_COST = 1500;

	//magic number
	/**Chance for an agent to be an innovator/facilitator */
	public static final double INNOVATOR_PROBABILITY = 0.35;	

	/** this is the amount required to join the stokvel */ 
	public static final int STOKVEL_AMOUNT = 50;
//	public static final int STOKVEL_AMOUNT = 150;

	/** Upper limit for the number of friends ... */
	public static final int FRIENDSHIP_UPPER_LIMIT = 7;

	
	//magic number
	/** critical min. no. for initiating a savings club */
//	public static final int MIN_SAVINGS_MEMBERS = 5;
	public static final int MIN_SAVINGS_MEMBERS = 3;

	/** health expenses cost */
//	public static final int HEALTH_EXPENSE = 200;	
	public static final int HEALTH_EXPENSE = 50;

	//initial hh money ; cash in hand
//	public static final int MIN_STARTING_WEALTH = 1500;
//	public static final int MAX_STARTING_WEALTH = 2500;
//	public static final int MIN_STARTING_WEALTH = 300;
//	public static final int MAX_STARTING_WEALTH = 700;
//	public static final int MIN_STARTING_WEALTH = 1500;
//	public static final int MAX_STARTING_WEALTH = 2000;
	public static final int MIN_STARTING_WEALTH = 500;
	public static final int MAX_STARTING_WEALTH = 1500;

	/**this is kept 30 Rands ... some say (probably, Radar) that it's
	 * usually 30Rands, could be way higher than 100 Rands as well ... don't know at the moment ... */
	public static final int FUNERALCLUB_FEE = 70;

	/** Yet another anecdotal account ... about the 'grace period' for the 
	 the number of months a household might benefit from a FC without paying the dues
	 */
	public static final int FUNERALCLUB_GRACE = 6;

	public static class MIGRATION {
		//magic number: 
		/**this is the minimum number months that a 'never' married agent
		 *would send the remittance ... after which we assume they marry in the city,
		 *maintain their links, but stop returning the money. 
		 */
		public static int SINGLE_REMITTANCE_LIMIT = 24;
		/** from Gina: this is the 1000 Rands ... minimum of the household money */
		public static int AMOUNT_REQD_MIGRATION = 1000;
		/**Initial number of migrants */
		public static double PROPORTION_INITIAL_MIGRANTS = 0.05;
	}

	/**
	 * Types of ARV treatments
	 * 
	 */
	public static class ARV_TREATMENT {
		public static final int NO_TREATMENT_CURRENTLY = 0;
		public static final int SINGLE_DOSE_NEVIRAPINE = 1;
		public static final int AZT_WITH_NEVIRAPINE = 2;
		public static final int TRIPLE_COMBINATION = 3;
		public static final int INFANT_TREATMENT_ONLY = 4;
	}

	public static class Church {
		/** number of denomination */	
		public static int NUMBER_DENOMINATIONS = 8;
		/** church particaption rate - from RADAR*/
		public static double CHURCH_PARTICIPATION_RATE = 0.8;		
	}
	
	/** Types of education levels*/
	public static final String[] educationLevels = {"none", "some-primary", "primary", "some-secondary", "secondary", "tertiary"};

	/**Household member type */
	public static class HOUSEHOLD_MEMBER_TYPE {
		public static final int CHILD = 0;
		public static final int GRANDCHILD = 1;
		public static final int OTHER = 2;
	}
	
	public static class MEMBERS_TYPE {
		public static final int CHILD = 0;
		public static final int GRANDCHILD = 1;
		public static final int OTHER = 2;
	}
	

	public static class MINE {
		/** Employment statuses at mine*/
		public static final String[] EMPLOYMENT_STATUS = {"unskilled", "underTraining", "skilled"};
		/**Mine's unskilled capacity limit */
		public static final int UNSKILLED_CAPACITY = 450;
		/**Mine's skilled capacity limit */
		public static final int SKILLED_CAPACITY = 100;
		/**Mine's starting time range */
		public static final int START_TICK_RANGE = 180;
		/**Mine's number of working months - age*/
		public static final int MINE_WORKING_MONTHS = 300;
	}
}