/**
 * A container for giving the instances names and for holding membership lists
 */
package units;

import java.util.ArrayList;

/**
 * @author scott, ruth, shah
 *
 */
public class Church {
	/** Households belonging to this church */ 
	ArrayList<Household> members = new ArrayList<Household>();
	/** ID of this church */
	int id = -1;
	int villageId = -1;
	public Church() {	
	}
	public Church(int _id) {
		this.id = _id;
	}
	public Church(int _id, int _villageId){
		this.id = _id;
		this.villageId = _villageId;
	}
	/**
	 * Add household to this church
	 * @param household
	 */
	public void addMember(Household household) {
		if (!members.contains(household)) {
			members.add(household);
			household.setChurch(this);
		}
	}	
	/**
	 * Remove household from this church
	 * @param household
	 */
	public void removeMember(Household household) {
		if (!members.contains(household)) {
			members.remove(household);
			household.setChurch(new Church());
		}
	}
	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}
	public int getVillageId() {
		return villageId;
	}
	public void setVillageId(int villageId) {
		this.villageId = villageId;
	}	
}